'use strict';const PropTypes=require('prop-types'),React=require('react'),shapeup=require('shapeup'),BasicTable=require('../basic-table/basic-table'),Panel=require('../panel/panel');class Status extends React.Component{constructor(a){super(a),this.STATUS_ERROR='error',this.STATUS_PENDING='pending',this.STATUS_OK='ok',this.STATUS_ORDER=[this.STATUS_ERROR,this.STATUS_PENDING,this.STATUS_OK],this.newHighest=null,this.state={highestStatus:this.STATUS_OK,statusFilter:null}}componentWillMount(){document.body.classList.add('u-is-status')}componentWillUnmount(){document.body.classList.remove('u-is-status')}componentWillReceiveProps(){this.setState({highestStatus:this.STATUS_OK})}componentDidUpdate(){this.newHighest&&this.state.highestStatus!==this.newHighest&&(this.setState({highestStatus:this.newHighest}),this.newHighest=null)}_setHighestStatus(a){const b=this._normaliseStatus(a);this.STATUS_ORDER.indexOf(b)<this.STATUS_ORDER.indexOf(this.state.highestStatus)&&(this.newHighest=b)}_getHighestStatus(a){const b=a.map((a)=>this._normaliseStatus(a));let c;return this.STATUS_ORDER.some((a)=>{if(-1<b.indexOf(a))return c=a,!0}),c}_getStatusClass(a,b){if(!b)return'';Array.isArray(b)||(b=[b]);const c=b.map((a)=>this._normaliseStatus(a));return a+this._getHighestStatus(c)}_normaliseStatus(a){let b=this.STATUS_OK;return'active'===a||'idle'===a||'started'===a||'waiting'===a?b=this.STATUS_OK:'blocked'===a||'down'===a||'error'===a?b=this.STATUS_ERROR:'pending'===a||'installing'===a||'executing'===a||'allocating'===a||'maintenance'===a?b=this.STATUS_PENDING:void 0,b}_generateStatusDisplay(a){return a?React.createElement('span',{className:this._getStatusClass('status-view__status--',a)},a):null}_byKey(c,a){return c.key<a.key?-1:c.key>a.key?1:0}_filterByStatus(a){return!this.state.statusFilter||a.extraData===this.state.statusFilter}_generateStatus(){const a=[],b=this.props.db,c=b.services.filter((a)=>!a.get('pending')),d=b.machines.filter((a)=>0!==a.id.indexOf('new')),e=b.relations.filter((a)=>!a.get('pending')),f={applications:c.length,machines:d.length,relations:e.length,remoteApplications:b.remoteServices&&b.remoteServices.size()||0,units:b.units&&b.units.size()||0},g=this.props.model;return g.modelUUID?(a.push(this._generateModel(g,f)),f.remoteApplications&&a.push(this._generateRemoteApplications(b.remoteServices)),f.applications&&a.push(this._generateApplications(c),this._generateUnits(c)),f.machines&&a.push(this._generateMachines(d)),f.relations&&a.push(this._generateRelations(e)),a):'Cannot show the status: the GUI is not connected to a model.'}_handleFilterChange(a){let b=a.currentTarget.value;'none'===b&&(b=null),this._changeFilterStatus(b)}_changeFilterStatus(a){this.setState({statusFilter:a})}_generateFilters(){const a=['none'].concat(this.STATUS_ORDER).map((a)=>{return React.createElement('option',{className:'status-view__filter-option',key:a,value:a},a)});return React.createElement('select',{className:'status-view__filter-select',onChange:this._handleFilterChange.bind(this),value:this.state.statusFilter||'none'},a)}_generateModel(a,b){const c=this.state.highestStatus;let d='Everything is OK';return c===this.STATUS_OK?d='Everything is OK':c===this.STATUS_PENDING?d='Items are pending':c===this.STATUS_ERROR?d='Items are in error':void 0,React.createElement('div',{key:'model'},React.createElement('div',{className:'twelve-col no-margin-bottom'},React.createElement('div',{className:'eight-col'},React.createElement('h2',null,a.environmentName,React.createElement('span',{className:'status-view__traffic-light '+`status-view__traffic-light--${c}`,onClick:this._changeFilterStatus.bind(this,c),role:'button',title:d,tabIndex:'0'}))),React.createElement('div',{className:'status-view__filter-label two-col'},'Filter status:'),React.createElement('div',{className:'status-view__filter two-col last-col'},this._generateFilters())),React.createElement(BasicTable,{headers:[{content:'Cloud/Region',columnSize:2},{content:'Version',columnSize:2},{content:'SLA',columnSize:1},{content:'Applications',columnSize:2},{content:'Remote applications',columnSize:2},{content:'Units',columnSize:1},{content:'Machines',columnSize:1},{content:'Relations',columnSize:1}],rows:[{columns:[{columnSize:2,content:`${a.cloud}/${a.region}`},{columnSize:2,content:a.version},{columnSize:1,content:a.sla},{columnSize:2,content:b.applications},{columnSize:2,content:b.remoteApplications},{columnSize:1,content:b.units},{columnSize:1,content:b.machines},{columnSize:1,content:b.relations}],key:'model'}]}))}_generateApplicationClickState(a){return{gui:{inspector:{id:a,activeComponent:void 0,unit:null,unitStatus:null}}}}_navigateToApplication(a,b){b.preventDefault(),this.props.changeState(this._generateApplicationClickState(a))}_generateCharmClickState(a){return{store:a}}_navigateToCharm(a,b){b.preventDefault(),this.props.changeState(this._generateCharmClickState(a))}_generateUnitClickState(a){const b=a.split('/');return{gui:{inspector:{id:b[0],unit:b[1],activeComponent:'unit'}}}}_navigateToMachine(a,b){b.stopPropagation(),b.preventDefault(),this.props.changeState(this._generateMachineClickState(a))}_generateMachineClickState(a){return{gui:{machines:a,status:null}}}_generateRemoteApplications(a){const b=a.map((a)=>{const b=a.getAttrs(),c=b.url.split(':');return{columns:[{columnSize:3,content:b.service},{columnSize:3,content:b.status.current},{columnSize:3,content:c[0]},{columnSize:3,content:c[1]}],extraData:this._normaliseStatus(b.status.current),key:b.url}});return React.createElement(BasicTable,{filterPredicate:this._filterByStatus.bind(this),headerClasses:['status-view__table-header'],headerColumnClasses:['status-view__table-header-column'],headers:[{content:'SAAS',columnSize:3},{content:'Status',columnSize:3},{content:'Store',columnSize:3},{content:'URL',columnSize:3}],key:'remote-applications',rowClasses:['status-view__table-row'],rowColumnClasses:['status-view__table-column'],rows:b,sort:this._byKey,tableClasses:['status-view__table']})}_realUnitsPredicate(a){return a.machine!==void 0&&0!==a.machine.indexOf('new')}_generateApplications(a){const b=this.props.urllib,c=a.map((a)=>{const c=a.getAttrs(),d=b.fromLegacyString(c.charm),e='cs'===d.schema?'jujucharms':'local',f=d.revision,g=d.path(),h=c.units.filter(this._realUnitsPredicate);return d.revision=null,this._setHighestStatus(c.status.current),{classes:[this._getStatusClass('status-view__table-row--',c.status.current)],clickState:this._generateApplicationClickState(c.id),columns:[{columnSize:2,content:React.createElement('span',null,React.createElement('img',{className:'status-view__icon',src:c.icon}),c.name)},{columnSize:2,content:c.workloadVersion},{columnSize:2,content:this._generateStatusDisplay(c.status.current)},{columnSize:1,content:h.length},{columnSize:2,content:React.createElement('a',{className:'status-view__link',href:this.props.generatePath(this._generateCharmClickState(g)),onClick:this._navigateToCharm.bind(this,g)},d.path())},{columnSize:2,content:e},{columnSize:1,content:f}],extraData:this._normaliseStatus(c.status.current),key:c.name}});return React.createElement(BasicTable,{changeState:this.props.changeState,filterPredicate:this._filterByStatus.bind(this),generatePath:this.props.generatePath,headerClasses:['status-view__table-header'],headerColumnClasses:['status-view__table-header-column'],headers:[{content:'Application',columnSize:2},{content:'Version',columnSize:2},{content:'Status',columnSize:2},{content:'Scale',columnSize:1},{content:'Charm',columnSize:2},{content:'Store',columnSize:2},{content:'Rev',columnSize:1}],key:'applications',rowClasses:['status-view__table-row'],rowColumnClasses:['status-view__table-column'],rows:c,sort:this._byKey,tableClasses:['status-view__table']})}_generateUnits(a){const b=(a)=>{return a?a.map((a)=>{return a.from===a.to?`${a.from}/${a.protocol}`:`${a.from}-${a.to}/${a.protocol}`}).join(', '):''},c=[];return a.forEach((a)=>{const d=a.get('exposed'),e=a.get('units').filter(this._realUnitsPredicate);e.forEach((e)=>{this._setHighestStatus(this._getHighestStatus([e.agentStatus,e.workloadStatus]));let f=e.public_address;if(d&&e.portRanges.length){const a=e.portRanges[0].from,b=`${e.public_address}:${a}`,c=443===a?'https':'http',d=`${c}://${b}`;f=React.createElement('a',{className:'status-view__link',href:d,target:'_blank'},e.public_address)}c.push({classes:[this._getStatusClass('status-view__table-row--',[e.agentStatus,e.workloadStatus])],clickState:this._generateUnitClickState(e.id),columns:[{columnSize:2,content:React.createElement('span',null,React.createElement('img',{className:'status-view__icon',src:a.get('icon')}),e.displayName)},{columnSize:2,content:this._generateStatusDisplay(e.workloadStatus)},{columnSize:2,content:this._generateStatusDisplay(e.agentStatus)},{columnSize:1,content:React.createElement('a',{className:'status-view__link',href:this.props.generatePath(this._generateMachineClickState(e.machine)),onClick:this._navigateToMachine.bind(this,e.machine)},e.machine)},{columnSize:2,content:f},{columnSize:1,content:b(e.portRanges)},{columnSize:2,content:e.workloadStatusMessage}],extraData:this._getHighestStatus([e.agentStatus,e.workloadStatus]),key:e.id})})}),c.length?React.createElement(BasicTable,{changeState:this.props.changeState,filterPredicate:this._filterByStatus.bind(this),generatePath:this.props.generatePath,headerClasses:['status-view__table-header'],headerColumnClasses:['status-view__table-header-column'],headers:[{content:'Unit',columnSize:2},{content:'Workload',columnSize:2},{content:'Agent',columnSize:2},{content:'Machine',columnSize:1},{content:'Public address',columnSize:2},{content:'Ports',columnSize:1},{content:'Message',columnSize:2}],key:'units',rowClasses:['status-view__table-row'],rowColumnClasses:['status-view__table-column'],rows:c.sort(this._byKey.bind(this,0)),sort:this._byKey,tableClasses:['status-view__table']}):null}_generateMachines(a){const b=a.map((a)=>{return this._setHighestStatus(a.agent_state),{classes:[this._getStatusClass('status-view__table-row--',a.agent_state)],clickState:this._generateMachineClickState(a.id),columns:[{columnSize:1,content:a.displayName},{columnSize:2,content:this._generateStatusDisplay(a.agent_state)},{columnSize:2,content:a.public_address},{columnSize:3,content:a.instance_id},{columnSize:1,content:a.series},{columnSize:3,content:a.agent_state_info}],extraData:this._normaliseStatus(a.agent_state),key:a.id}});return React.createElement(BasicTable,{changeState:this.props.changeState,filterPredicate:this._filterByStatus.bind(this),generatePath:this.props.generatePath,headerClasses:['status-view__table-header'],headerColumnClasses:['status-view__table-header-column'],headers:[{content:'Machine',columnSize:1},{content:'State',columnSize:2},{content:'DNS',columnSize:2},{content:'Instance ID',columnSize:3},{content:'Series',columnSize:1},{content:'Message',columnSize:3}],key:'machines',rowClasses:['status-view__table-row'],rowColumnClasses:['status-view__table-column'],rows:b.sort(this._byKey.bind(this,0)),sort:this._byKey,tableClasses:['status-view__table']})}_generateRelationAppLink(a){const b=this.props.db.services.getById(a);return b?React.createElement('a',{className:'status-view__link',href:this.props.generatePath(this._generateApplicationClickState(a)),onClick:this._navigateToApplication.bind(this,a)},React.createElement('img',{className:'status-view__icon',src:b.get('icon')}),a):React.createElement('span',null,a)}_generateRelations(a){const b=a.map((a)=>{const b=a.getAttrs();let c='',d='',e='',f='';return b.endpoints.forEach((a)=>{const b=a[0],g=a[1];switch(g.role){case'peer':return c=g.name,d=b,e=b,void(f='peer');case'provider':c=g.name,e=b,f='regular';break;case'requirer':d=b;}}),{columns:[{columnSize:3,content:c},{columnSize:3,content:this._generateRelationAppLink(d)},{columnSize:3,content:this._generateRelationAppLink(e)},{columnSize:3,content:f}],key:b.id}});return React.createElement(BasicTable,{filterPredicate:this._filterByStatus.bind(this),headerClasses:['status-view__table-header'],headerColumnClasses:['status-view__table-header-column'],headers:[{content:'Relation',columnSize:3},{content:'Provides',columnSize:3},{content:'Consumes',columnSize:3},{content:'Type',columnSize:3}],key:'relations',rowClasses:['status-view__table-row'],rowColumnClasses:['status-view__table-column'],rows:b.sort(this._byKey.bind(this,0)),sort:this._byKey,tableClasses:['status-view__table']})}render(){return React.createElement(Panel,{instanceName:'status-view',visible:!0},React.createElement('div',{className:'status-view__content'},this._generateStatus()))}}Status.propTypes={changeState:PropTypes.func.isRequired,db:shapeup.shape({machines:shapeup.shape({filter:PropTypes.func.isRequired}).isRequired,relations:shapeup.shape({filter:PropTypes.func.isRequired}).isRequired,remoteServices:shapeup.shape({map:PropTypes.func.isRequired,size:PropTypes.func.isRequired}).isRequired,services:shapeup.shape({filter:PropTypes.func.isRequired,getById:PropTypes.func.isRequired}).isRequired}).frozen.isRequired,generatePath:PropTypes.func.isRequired,model:shapeup.shape({cloud:PropTypes.string,environmentName:PropTypes.string,modelUUID:PropTypes.string,region:PropTypes.string,sla:PropTypes.string,version:PropTypes.string}).frozen.isRequired,urllib:shapeup.shape({fromLegacyString:PropTypes.func.isRequired}).frozen.isRequired},module.exports=Status;