'use strict';const zip=require('zip'),proxyquire=require('proxyquire'),entries=['readme','version'],ReaderStub=sinon.stub().returns({toObject:sinon.stub().returns(entries)}),zipUtils=proxyquire('./zip-utils',{zip:{Reader:ReaderStub}});describe('Zip utils',function(){describe('getEntries',function(){let a,b,c,d,e;const f='a file object';beforeEach(function(){e=window.FileReader,a=sinon.stub();const f=function(){};f.prototype.addEventListener=a,f.prototype.readAsArrayBuffer=sinon.stub(),window.FileReader=f,d=sinon.stub(zip,'createReader'),b=sinon.stub(),c=sinon.stub()}),afterEach(function(){window.FileReader=e,d.restore()}),it('can get entries from a zip file',function(){a.withArgs('loadend').callsArgWith(1,{target:{result:'file'}}),zipUtils.getEntries(f,b,c),assert.equal(b.callCount,1),assert.deepEqual(b.args[0][0],entries)}),it('can handle errors when getting entries',function(){a.withArgs('onerror').callsArg(1),zipUtils.getEntries(f,b,c),assert.equal(c.callCount,1)})}),describe('splitPath',function(){it('correctly splits a full path',function(){const a=zipUtils.splitPath('/my/path/filename.ext');assert.strictEqual(a.dirname,'/my/path'),assert.strictEqual(a.basename,'filename.ext')}),it('correctly splits a relative path',function(){const a=zipUtils.splitPath('relative/filename.ext');assert.strictEqual(a.dirname,'relative'),assert.strictEqual(a.basename,'filename.ext')}),it('correctly splits a directory path',function(){const a=zipUtils.splitPath('/my/path/');assert.strictEqual(a.dirname,'/my/path'),assert.strictEqual(a.basename,'')}),it('correctly splits a file path',function(){const a=zipUtils.splitPath('filename.ext');assert.strictEqual(a.dirname,''),assert.strictEqual(a.basename,'filename.ext')})}),describe('findCharmEntries',function(){it('finds all the charm interesting files',function(){const a='/foo/config.yaml contents',b='/foo/metadata.yaml contents',c='/foo/README.rst contents',d='/foo/revision contents',e=zipUtils.findCharmEntries({"file1.py":'file1.py contents',foo:'foo contents',"/foo/config.yaml":a,"/foo/file2.yaml":'/foo/file2.yaml contents',"/foo/metadata.yaml":b,"/foo/revision":d,"/foo/file2.yaml":'/foo/file2.yaml contents',"/foo/README.rst":c});assert.deepEqual(e,{config:a,metadata:b,readme:c,revision:d})}),it('returns the entries found, even if some are missing',function(){const a='metadata.yaml contents',b='revision contents',c=zipUtils.findCharmEntries({"metadata.yaml":a,"HACKING.rst":'HACKING.rst contents',revision:b,"tests/setup.py":'tests/setup.py contents'});assert.deepEqual(c,{metadata:a,revision:b})}),it('returns an empty object if no entries are found',function(){const a=zipUtils.findCharmEntries({mycharm:'mycharm contents',"mycharm/hooks":'mycharm/hooks contents',"mycharm/hooks/start":'mycharm/hooks/start contents'});assert.deepEqual(a,{})}),it('ignores pseudo entries in non-charm-root directories',function(){const a='/mycharm/metadata.yaml contents',b='/mycharm/README contents',c=zipUtils.findCharmEntries({mycharm:'mycharm contents',"/mycharm/metadata.yaml":a,"mycharm/hooks":'mycharm/hooks contents',"mycharm/hooks/config.yaml":'mycharm/hooks/config.yaml contents',"/mycharm/README":b,revision:'revision contents'});assert.deepEqual(c,{metadata:a,readme:b})}),it('finds exotic documentation files',function(){let a,b;['README.txt','ReadMeCarefully.md','readme'].forEach(function(c){let d={};b=`${c} contents`,d[c]=b,a=zipUtils.findCharmEntries(d),assert.deepEqual(a,{readme:b},c)})})}),describe('readCharmEntries',function(){let a,b;beforeEach(function(){a=sinon.stub();const c=new TextEncoder;b={file1:c.encode('file1 contents'),file2:c.encode('file2 contents')}}),it('reads data from each entry',function(){zipUtils.readCharmEntries(b,a),assert.equal(a.callCount,1),assert.deepEqual(a.args[0][0],{file1:'file1 contents',file2:'file2 contents'})})})});