'use strict';const d3=require('d3'),jsyaml=require('js-yaml'),environmentUtils=require('./environment-utils'),relationUtils=require('../relation-utils'),topoUtils=require('./utils'),zipUtils=require('../zip-utils');class ServiceModule{constructor(a={}){this.name='ServiceModule',this.useTransitions=a.useTransitions||!1,this.DRAG_START=1,this.DRAG_ACTIVE=2,this.events={scene:{".service":{click:'serviceClick',mouseover:'serviceMouseEnter',mouseout:'serviceMouseLeave',mousemove:'serviceMouseMove'},".zoom-plane":{mouseup:'canvasClick'}},d3:{".service":{"mousedown.addrel":'serviceAddRelMouseDown',"mouseup.addrel":'serviceAddRelMouseUp'}},topo:{highlight:'highlight',unhighlight:'unhighlight',show:'show',hide:'hide',fade:'fade',dragstart:'dragstart',drag:'drag',dragend:'dragend',clearState:'clearStateHandler',panToCenter:'panToCenter',bundleImportComplete:'panToBundle'}},this.subordinate_margins={top:0.05,bottom:0.1,left:0.084848,right:0.084848},this.service_margins={top:0.01,bottom:0.01,left:0.01,right:0.01},this.currentServiceClickAction='showServiceDetails',this.centerOnLoad=!0}updateData(){var a=this.topo,b=a.vis,c=a.db,d=a.env,e=c.services.visible();environmentUtils.toBoundingBoxes(this,e,a.service_boxes,d);var f=e.size();e.reset(),this.node=b.selectAll('.service').data(Object.keys(a.service_boxes).map((b)=>a.service_boxes[b]),function(a){return a.modelId}),this.centerOnLoad&&0<f&&(this.centerOnLoad=!1,setTimeout(()=>{this.panToCenter()}))}updateServiceNodes(a){if(!a.empty()){var b=this,c=this.topo,e=0;a.each(function(a){var d,f,g=a.model,h=g.get('annotations');if((a.w=a.subordinate?a.h=130:a.h=190,h&&!a.inDrag)&&(d=h['gui-x'],f=h['gui-y'],void 0!==d&&void 0!==f)&&(d=parseFloat(d),f=parseFloat(f),(d!==a.x||f!==a.y)&&!a.inDrag)){var i=b.useTransitions;b.drag.call(this,a,b,{x:d,y:f},i),e+=1,c.annotateBoxPosition(a)}}),1<e&&this.findCentroid(),a.filter(function(a){return a.subordinate}).classed('subordinate',!0),a.attr({width:function(a){return a.w},height:function(a){return a.h}}),a.select('.service-block').attr({cx:function(a){return a.subordinate?65:95},cy:function(a){return a.subordinate?65:95},r:function(a){return a.subordinate?60:90}}),a.select('.service-block__halo').attr({cx:function(a){return a.subordinate?65:95},cy:function(a){return a.subordinate?65:95},r:function(a){return a.subordinate?80:110}}),a.select('.service-icon').attr('transform',function(a){return a.subordinate?'translate(17, 17)':'translate(47, 47)'}),a.select('.relation-button').attr('transform',function(a){return'translate('+[a.subordinate?65:95,30]+')'});var f=!1;a.select('.service-block').each(function(a){var b=d3.select(this),c=d3.select(this.parentNode),d=!1,e=!1,g=!1;if(a.subordinate)b.attr({stroke:'#888888',"stroke-width":1});else if(a.pending||a.deleted)b.attr({stroke:'#19b6ee',"stroke-width":3}),e=!0,f=!0;else if(a.highlighted)f=!0;else{var h=a.units._items;h.forEach(function(a){'installing'===a.agent_state||'pending'===a.agent_state?d=!0:'error'===a.agent_state?g=!0:!a.agent_state&&(e=!0)}),f=!0}g?c.classed('is-erroring',!0).classed('is-pending',!1).classed('is-uncommitted',!1).classed('is-running',!1):d?c.classed('is-pending',!0).classed('is-erroring',!1).classed('is-uncommitted',!1).classed('is-running',!1):e?c.classed('is-uncommitted',!0).classed('is-erroring',!1).classed('is-pending',!1).classed('is-running',!1):c.classed('is-running',!0).classed('is-erroring',!1).classed('is-uncommitted',!1).classed('is-pending',!1),b.attr({width:a.w,height:a.h})}),f&&document.dispatchEvent(new Event('topo.rerenderRelations'));var d=a.filter(function(a){return d3.select(this).select('.sub-rel-block').empty()&&a.subordinate}).insert('g',':first-child').attr('class','sub-rel-block').attr('transform',function(a){return'translate('+[a.w-5,a.h/2-26]+')'});d.append('line').attr({x1:0,y1:30,x2:20,y2:30}).attr('stroke-width',1).attr('stroke','#888888'),d.append('circle').attr({cx:0,cy:30,r:4}).attr('fill','#888888'),d.append('circle').attr({cx:35,cy:30,r:15}).attr('stroke-width',1.1).attr('stroke','#888888').attr('fill','#f5f5f5'),d.append('text').append('tspan').attr({class:'sub-rel-count',x:30,y:36});var g=224,h=22,i=16;a.select('.name').attr({style:function(a){return'font-size:'+a.h*(h/g)+'px'},x:function(a){return a.w/2},y:function(a){return a.h*(26/g)+a.h*(h/g)/2}}),a.select('.name').text(function(a){return b.truncateServiceName(a)}),a.select('.charm-label').attr({style:function(a){return'font-size:'+a.h*(i/g)+'px'},x:function(a){return a.w/2},y:function(a){return a.h*(150/g)-a.h*(i/g)/2}});var j=a.filter(function(a){return a.exposed});j.each(function(){d3.select(this).classed('is-exposed',!0)});var k=a.filter(function(a){return!a.exposed});k.each(function(){d3.select(this).classed('is-exposed',!1)})}}getContainer(a){a=a?a:this;const b=a.topo.container;return b.getDOMNode&&b.getDOMNode()||b}_delegate(a,b,c){const d=this.getContainer(this);d.addEventListener(a,(a)=>{(a.target.classList.contains(c)||a.target.closest(`.${c}`))&&b(a)})}_attachDragEvents(){const a='zoom-plane',b='environment-help';this._delegate('drop',this.canvasDropHandler.bind(this),a),this._delegate('dragenter',this._ignore.bind(this),a),this._delegate('dragover',this._ignore.bind(this),a),this._delegate('drop',this.canvasDropHandler.bind(this),b),this._delegate('dragenter',this._ignore.bind(this),b),this._delegate('dragover',this._ignore.bind(this),b)}panToBundle(a){var b=this.topo,c=a.services,d=[];c.forEach(function(a){var c=b.service_boxes[a.get('id')];c&&d.push([c.x,c.y])}),this.findCentroid(d)}_ignore(a){a.preventDefault()}attachTouchstartEvents(a,b){const c=this.topo;d3.select(b).classed('pending')||b.addEventListener('touchstart',this._touchstartServiceTap,this,c)}_touchstartServiceTap(a){var b=a.currentTarget,c=d3.select(b).datum();return 1<a.touches.length?void(c.tapped=!1):void(c.tapped=!0,this.serviceClick.call(b,c,this,'touch'))}hoverService(a,b){var c=this.getServiceNode(a);c&&(b?topoUtils.addSVGClass(c,'hover'):this.unhoverServices())}unhoverServices(){this.topo.vis.selectAll('.hover').classed('hover',!1)}deselectNodes(){var a=this.topo;a.vis.selectAll('.is-selected').classed('is-selected',!1)}selectNode(a){this.deselectNodes(),topoUtils.addSVGClass(a,'is-selected')}selectService(a){var b=this.getServiceNode(a);b&&this.selectNode(b)}panToService(a){var b=this.getServiceNode(a);if(b){var c=d3.select(b).datum();document.dispatchEvent(new CustomEvent('topo.panToPoint',{detail:[{point:[c.x,c.y]}]}))}}_raiseToTop(c){d3.selectAll('.the-canvas .service').sort((d,a)=>{return d.id===c?1:a.id===c?-1:0})}serviceClick(a,b,c){var d=b.topo;const e=b.getContainer(b);if('touch'!==c){var f=d3.mouse(e.querySelector('.the-canvas'));if(!a.containsPoint(f,d.zoom))return}else a.ignoreNextClick=!0;if(a.ignoreNextClick)return void(a.ignoreNextClick=!1);if(d.ignoreServiceClick)return void(d.ignoreServiceClick=!1);var g=b.currentServiceClickAction;a.node&&b.selectNode(a.node),b[g](a,d),b._raiseToTop(a.id)}serviceMouseEnter(a){document.dispatchEvent(new CustomEvent('topo.hoverService',{detail:{id:a.id}}));var b=this.closest('.service');topoUtils.hasSVGClass(b,'selectable-service')&&document.dispatchEvent(new CustomEvent('topo.snapToService',{detail:[{service:a,rect:b}]}))}serviceMouseLeave(a,b){var c=b.topo;document.dispatchEvent(new CustomEvent('topo.hoverService',{detail:{id:null}})),b.unhoverServices();const d=b.getContainer(b);var e=d3.mouse(d.querySelector('.the-canvas'));a.containsPoint(e,c.zoom)||document.dispatchEvent(new Event('topo.snapOutOfService'))}serviceMouseMove(){document.dispatchEvent(new Event('topo.mouseMove'))}canvasClick(a,b){var c=b.topo;c.zoomed||document.dispatchEvent(new Event('topo.clearState'))}canvasDropHandler(a){a.preventDefault();var b=a.dataTransfer.files,c=this.topo,d=c.env,e=c.db;return this._canvasDropHandler(b,c,d,e,a)}_canvasDropHandler(a,b,c,d,e){var f=this;if(a&&a.length)Array.prototype.forEach.call(a,function(a){var e=a.name.split('.').slice(-1).toString();('application/zip'===a.type||'application/x-zip-compressed'===a.type)&&'zip'===e?f._extractCharmMetadata.call(f,a,b,c,d):f.topo.bundleImporter.importBundleFile(a)});else return void this._deployFromCharmbrowser(e,b);return'event ignored'}_deployLocalCharm(a){window.localCharmFile=a,this.topo.state.changeState({gui:{inspector:{id:null,localType:'new'}}})}_extractCharmMetadata(a,b,c,d){zipUtils.getEntries(a,this._findCharmEntries.bind(this,a,b,c,d),this._zipExtractionError.bind(this,d,b,a))}_findCharmEntries(a,b,c,d,e){var f=zipUtils.findCharmEntries(e);return f.metadata?void this._readCharmEntries(a,b,c,d,f):(d.notifications.add({title:'Import failed',message:'Import from "'+a.name+'" failed. Invalid charm file, missing metadata.yaml',level:'error'}),void b.environmentView.fadeHelpIndicator(!1))}_readCharmEntries(a,b,c,d,e){zipUtils.readCharmEntries(e,this._checkForExistingServices.bind(this,a,b,c,d),this._zipExtractionError.bind(this,d,b,a))}_checkForExistingServices(a,b,c,d,e){const f=jsyaml.safeLoad(e.metadata).name,g=d.services.getServicesFromCharmName(f);0<g.length?this._showUpgradeOrNewInspector(a,c,d):this._deployLocalCharm(a,c,d)}_zipExtractionError(a,b,c,d){a.notifications.add({title:'Import failed',message:'Import from "'+c.name+'" failed. See console for error object',level:'error'}),console.error(d),b.environmentView.fadeHelpIndicator(!1)}_showUpgradeOrNewInspector(a){window.localCharmFile=a,this.topo.state.changeState({gui:{inspector:{id:null,localType:'update'}}})}_deployFromCharmbrowser(a,b){var c=JSON.parse(a.dataTransfer.getData('Text')),d=b.getTranslate(),e=b.getScale(),f={coordinates:[]},g=[a.clientX,a.clientY-71];if(g.forEach((a,b)=>{f.coordinates[b]=(g[b]-d[b])/e}),'token-drag-and-drop'===c.dataType){var h=JSON.parse(c.data);let a='charm';if(h&&h.id&&-1<h.id.indexOf('bundle')&&(a='bundle'),'charm'==a){f.icon=c.iconSrc;var i=new window.models.Charm(h);document.dispatchEvent(new CustomEvent('initiateDeploy',{detail:{charm:i,ghostAttributes:f}}))}else{this.topo.db.notifications.add({title:'Processing File',message:'Changeset processing started.',level:'important'});var j=b.charmstore;j.getBundleYAML(h.id.replace('cs:',''),function(a,c){return a?void console.error(a):void b.bundleImporter.importBundleYAML(c)}.bind(this))}}}clearStateHandler(){var a=this.topo;const b=this.getContainer();b.querySelectorAll('.environment-menu.active').forEach((a)=>{a.classList.remove('active')}),this.deselectNodes(),this.unhoverServices(),a.state.changeState({root:null,user:null,gui:{machines:null,inspector:null},hash:null,search:null,store:null})}allowBuildRelation(a,b){var c=a.db.charms.getById(b.get('charm'));return c&&c.loaded}serviceAddRelMouseDown(a,b){var c=d3.event,f=b.topo;b.longClickTimer=window.setTimeout((c,d)=>{var e=Math.abs;5<(e(a.x-a.px)+e(a.y-a.py))/2||!b.allowBuildRelation(f,a.model)||(d3.event=d,!f.buildingRelation&&document.dispatchEvent(new CustomEvent('topo.addRelationDragStart',{detail:[{service:a}]})))},250,a,c)}serviceAddRelMouseUp(a,b){b.longClickTimer&&window.clearInterval(b.longClickTimer)}dragstart(a,b){var c=b.topo;return a.inDrag=b.DRAG_START,b._raiseToTop(a.id),this.clickTimer=!1,c.lastBoxClicked&&a.id!==c.lastBoxClicked?(this.clickTimer=!0,void(c.lastBoxClicked=a.id)):void(window.clearTimeout(this.timeout),this.timeout=setTimeout(()=>{this.clickTimer=!0,c.lastBoxClicked=a.id},100))}dragend(a,b){var c=b.topo;if(!(a.tapped&&(a.tapped=!1,!c.buildingRelation)))if(c.buildingRelation&&this.clickTimer)c.ignoreServiceClick=!0,document.dispatchEvent(new Event('topo.addRelationDragEnd')),c.lastBoxClicked=void 0;else{if(a.inDrag!==b.DRAG_ACTIVE)return;c.ignoreServiceClick=!0,c.annotateBoxPosition(a)}}drag(a,b,c,d){if(!a.tapped){var e=b.topo,f=d3.select(this);if(e.buildingRelation){if(a)return void document.dispatchEvent(new CustomEvent('topo.addRelationDrag',{detail:[{box:a}]}));e.buildingRelation=!1}b.longClickTimer&&window.clearInterval(b.longClickTimer),c?(a.x=c.x,a.y=c.y):(a.x+=d3.event.dx,a.y+=d3.event.dy),d&&(f=f.transition().duration(500).ease('elastic')),f.attr('transform',function(a){return a.translateStr});const g=b.getContainer();g.querySelectorAll('.environment-menu.active').forEach((a)=>{a.classList.remove('active')}),a.inDrag===b.DRAG_START&&(a.inDrag=b.DRAG_ACTIVE),document.dispatchEvent(new Event('topo.cancelRelationBuild')),document.dispatchEvent(new CustomEvent('topo.serviceMoved',{detail:[{service:a}]}))}}update(){var a=this,b=this.topo,c=b.getWidth(),d=b.getHeight();this.rendered||(this._attachDragEvents(),this.rendered=!0),this.service_scale||(this.service_scale=d3.scale.log().range([150,200]),this.service_scale_width=d3.scale.log().range([164,200]),this.service_scale_height=d3.scale.log().range([64,100])),this.dragBehavior||(this.dragBehavior=d3.behavior.drag().on('dragstart',function(b){a.dragstart.call(this,b,a)}).on('drag',function(b){a.drag.call(this,b,a)}).on('dragend',function(b){a.dragend.call(this,b,a)})),this.updateData();var e=this.node;e.on('mousewheel.zoom',b.handleZoom.bind(b)).on('wheel.zoom',b.handleZoom.bind(b));var f=[];Object.keys(b.service_boxes).forEach((a)=>{const c=b.service_boxes[a];var d=c.annotations,e=0;d['gui-x']&&c.x===void 0&&(c.x=d['gui-x'],e+=1),d['gui-y']&&c.y===void 0&&(c.y=d['gui-y'],e+=1),2!=e||c.model.get('pending')||f.push([c.x,c.y])});var g=Object.keys(b.service_boxes).map((a)=>b.service_boxes[a]).filter(function(a){if(a.model){var b=a.model.get('annotations');return isNaN(a.x)&&!(b&&b['gui-x'])}return!1});if(0<g.length)if(1===g.length&&g[0].model.get('pending')&&(void 0===g[0].x||void 0===g[0].y)){var h=b.servicePointOutside();g[0].x=h[0],g[0].y=h[1],document.dispatchEvent(new CustomEvent('topo.panToPoint',{detail:[{point:h}]}))}else{if(d3.layout.pack().size([c,d]).value(function(a){return Math.max(a.unit_count,1)}).padding(300).radius(50).nodes({children:g}),g.length<Object.keys(b.service_boxes).length){var i,j=[];g.forEach((a)=>{i=b.servicePointOutside(j),a.x+=i[0]-a.x,a.y+=i[1]-a.y,j.push([a.x,a.y])})}g.forEach((a)=>{var c=a.model.get('annotations')||{};c&&c['gui-x']?0<f.length&&f.push([c['gui-x']||a.x||0,c['gui-y']||a.y||0]):(f.push([a.x||0,a.y||0]),b.annotateBoxPosition(a))})}e.enter().append('g').attr({"pointer-events":'all',class:function(a){return(a.subordinate?'subordinate ':'')+'service'}}).call(this.dragBehavior).call(a.createServiceNode,a).attr('transform',function(a){return a.translateStr}),a.updateServiceNodes(e),e.exit().each(function(a){delete b.service_boxes[a.id]}).remove(),this.updateElementVisibility()}panToCenter(){var a=this.topo,b=topoUtils.serviceBoxesToVertices(a.service_boxes);this.findCentroid(b)}findCentroid(a){const b=topoUtils.centroid(a);document.dispatchEvent(new CustomEvent('topo.panToPoint',{detail:[{point:b,center:!0}]}))}getServiceNode(a){if(this.node===void 0)return null;var b=this.node.filter(function(b){return b.id===a});return b&&b[0][0]||null}truncateServiceName(a){var b=a.displayName;return a.pending&&(b=b.match(/^\(?(.{0,}?)\)?$/)[1]),10<b.length&&(b=b.substr(0,9)+'\u2026'),a.pending&&(b='('+b+')'),b}createServiceNode(a,b){var c=b.topo.staticURL||'';c&&(c+='/');var d=`${c}static/gui/build/app`;a.attr({"data-name":function(a){return a.name}});var e=a.filter(function(){return d3.select(this).select('.relation-button').empty()}).insert('g',':first-child').attr('class','relation-button').attr('transform',function(a){return'translate('+[a.subordinate?65:95,30]+')'});e.append('line').attr({x1:0,y1:0,x2:0,y2:30}).attr('stroke-width',1).attr('stroke','#888888'),e.append('circle').attr({cx:0,cy:34,r:4}).attr('fill','#888888'),e.append('circle').classed('relation-button__link',!0).attr({cx:0,cy:0,r:15,fill:'#f8f8f8',stroke:'#888888',"stroke-width":1.1}).on('mousedown',function(a){document.dispatchEvent(new CustomEvent('topo.addRelationDragStart',{detail:[{service:a}]}))}).on('click',function(a){document.dispatchEvent(new CustomEvent('topo.addRelationDragStart',{detail:[{service:a}]}))}),e.append('image').classed('relation-button__image',!0).attr({"xlink:href":`${d}/assets/svgs/build-relation_16.svg`,width:16,height:16,transform:'translate(-8, -8)'}),a.append('circle').attr({cx:function(a){return a.subordinate?65:95},cy:function(a){return a.subordinate?65:95},r:function(a){return a.subordinate?80:110},fill:'transparent',"stroke-dasharray":'5, 5'}).classed('service-block__halo',!0),a.append('circle').attr({cx:function(a){return a.subordinate?65:95},cy:function(a){return a.subordinate?65:95},r:function(a){return a.subordinate?60:90},fill:'#f5f5f5',"stroke-width":1,stroke:'#888888'}).classed('service-block',!0),a.append('image').classed('service-icon',!0).attr({"xlink:href":function(a){return a.icon},width:96,height:96,transform:function(a){return a.subordinate?'translate(17, 17)':'translate(47, 47)'},"clip-path":function(){return'url(#clip-mask)'}}),a.each(function(a){b.attachTouchstartEvents(a,this)})}updateElementVisibility(){var a,b,c,d,e={fade:[],highlight:[],hide:[],show:[]},f=this.topo.db;f.services.each(function(f){a=f.get('fade'),c=f.get('highlight'),b=f.get('hide'),d=f.get('id'),a&&e.fade.push(d),c&&e.highlight.push(d),b&&e.hide.push(d),a||c||b||e.show.push(d)}),0<e.fade.length&&(this.show({serviceNames:e.fade}),this.unhighlight({serviceName:e.fade}),this.fade({serviceNames:e.fade})),0<e.highlight.length&&(this.show({serviceNames:e.highlight}),this.highlight({serviceName:e.highlight})),0<e.hide.length&&(this.unhighlight({serviceName:e.hide}),this.hide({serviceNames:e.hide})),0<e.show.length&&(this.unhighlight({serviceName:e.show}),this.show({serviceNames:e.show}))}highlight(a){var b=[a.serviceName];Array.isArray(a.serviceName)&&(b=a.serviceName);var c=this.topo;if(a.highlightRelated){var d=c.service_boxes[b[0]].model,e=relationUtils.getRelationDataForService(c.db,d);e.forEach(function(a){b.push(a.far.service)})}b.forEach(function(a){c.service_boxes[a].highlighted=!0});var f=this.selectionFromServiceNames(b);f.classed(topoUtils.getVisibilityClasses('highlight'))}unhighlight(a){var b=[a.serviceName];Array.isArray(a.serviceName)&&(b=a.serviceName);var c=this.topo;if(a.unhighlightRelated){var d=c.service_boxes[b[0]].model,e=relationUtils.getRelationDataForService(c.db,d);e.forEach(function(a){b.push(a.far.service)})}b.forEach(function(a){c.service_boxes[a].highlighted=!1});var f=this.selectionFromServiceNames(b);f.classed(topoUtils.getVisibilityClasses('unhighlight'));var g,h;f.each(function(a){g=d3.select(this).select('.service-block-image'),h='static/gui/build/app/assets/svgs/service_module.svg',(a.pending||a.deleted)&&(h='static/gui/build/app/assets/svgs/service_module_pending.svg'),g.attr('href',h)})}show(a){var b=a.selection;if(!b){var c=a.serviceNames;c&&0!==c.length||(c=Object.keys(this.topo.service_boxes)),b=this.selectionFromServiceNames(c)}b.classed(topoUtils.getVisibilityClasses('show'))}hide(a){var b=a.selection;if(!b){var c=a.serviceNames;if(!c)return;b=this.selectionFromServiceNames(c)}b.classed(topoUtils.getVisibilityClasses('hide'))}fade(a){var b=a.selection;if(!b){var c=a.serviceNames;if(!c)return;b=this.selectionFromServiceNames(c)}b.classed(topoUtils.getVisibilityClasses('fade'))}selectionFromServiceNames(a){var b=this.topo;return b.vis.selectAll('.service').filter(function(b){return-1<a.indexOf(b.id)})}backgroundClicked(){document.dispatchEvent(new Event('topo.clearState'))}showServiceDetails(a,b){b.state.changeState({gui:{inspector:{id:a.id,activeComponent:void 0,unit:null,unitStatus:null}}})}show_service(a){var b=this.topo,c=b.createServiceInspector;b.detachContainer(),c(a)}}module.exports=ServiceModule;